#include <cstdio>

// dependence of c-pragma.h
#include <gcc-plugin.h>
// c_register_pragma
#include <c-family/c-pragma.h>
// IDENTIFIER_POINTER
#include <tree.h>
//// vec
//#include <vec.h>
//gcc error
#include <diagnostic.h>

#include "mpi_collective.hpp"

void register_mpicoll_check_pragma(void *event_data, void *data)
{
	(void) event_data;
	(void) data;
	printf("registering pragma: \"ProjectCA\"\n");
	c_register_pragma("ProjetCA", "mpicoll_check", mpicoll_check_pragma);
}

//simple function to print fun_vec elements.
void print_fun_vec()
{
	tree x;
	for (unsigned int ix=0;fun_vec.iterate(ix, &x);ix++)
	{
		printf("%s ",IDENTIFIER_POINTER(x));
	}
	printf("\n%i",fun_vec.length());	
	printf("\n");
}

//add x if not present in fun_vec
void add_to_fun_vec(tree x)
{
	//verify if a newly added name is not already present in fun_vec.
	//raise warning if so.
	if (fun_vec.contains(x))
	{
		warning (0,"repetition of function name %s in pragma"
				, IDENTIFIER_POINTER(x));
		return;
	}  
	fun_vec.quick_push(x);
} 

//By "taking inspiration", I just cc/cv and modified what was needed for
//our needs.
void mpicoll_check_pragma(cpp_reader *)
{
	location_t loc;
	enum cpp_ttype token;
	tree x;
	bool close_paren_needed_p = false;
	
	//not possible to use pragma inside function
	if (cfun)
	{
		error_at (cfun->function_start_locus
		          , "pragma ProjetCA %s is not allowed inside functions"
		          , "mpicoll_check");
		return;
	}

	token = pragma_lex (&x, &loc);
	if (token == CPP_OPEN_PAREN)
	{
		close_paren_needed_p = true;
		token = pragma_lex (&x, &loc);
	}

	if (token != CPP_NAME)
	{ error_at (loc, "%<#pragma ProjetCA mpicoll_check%> is not a valid name"); }

	/* Strings are user options.  */
	else
	{
		//tree args = NULL_TREE;

		do
		{
			/* Build up the strings now as a tree linked list.  Skip empty
			   strings.  */
			if (IDENTIFIER_LENGTH (x) > 0) 
			//I have no idea what type is CPP_NAME; But it doesn't seem to create
			//a string since TREE_STRING_LENGTH fails ; IDENTIFIER_LENGTH works
			//just fine for what we want.
			//
			//The Tree structure stuff is a mess.
			{ 
				if (token != CPP_NAME)
				{
					//turns out this never happens..
					warning_at (loc, 0,"Unrecognized name %s", IDENTIFIER_POINTER(x));
				}
				//args = tree_cons (NULL_TREE, x, args);
				inform (loc, "Registering name %s", IDENTIFIER_POINTER(x));	
				add_to_fun_vec(x);
				print_fun_vec();
			}

			token = pragma_lex (&x);
			while (token == CPP_COMMA)
			{ token = pragma_lex (&x); }
		}
		while (token == CPP_NAME);

		if (close_paren_needed_p)
		{
			if (token == CPP_CLOSE_PAREN)
			{ token = pragma_lex (&x,&loc); }
			else
				error ("%<#pragma ProjetCA %s (string [,string]...)%> does "
				         "not have a final %<)%>", "mpicoll_check");
		}

		if (token != CPP_EOF)
		{
			error_at (loc,"%<#pragma ProjetCA %s%> string is badly formed"
					, "mpicoll_check");
			return;
		}

		/* put arguments in the order the user typed them.  */
		//args = nreverse (args);
	}
}

/* OLD - TODO : delete this
void mpicoll_check_pragma(cpp_reader *)
{
	location_t loc;
	cpp_ttype token;
	tree x;

	// on a pas acces a la fonction courante sans passer par cfun
	if (cfun)
	{
		error_at (cfun->function_start_locus
		          , "pragma ProjectCA %s is not allowed inside functions"
		          , "mpicoll_check");
		return;
	}

	token = pragma_lex(&x, &loc);
	if (token == CPP_NAME)
	{
		printf("adding %s to function to parse.\n", IDENTIFIER_POINTER(x));
	}
}
*/

void verify_mpicoll_list(void *event_data, void *data)
{
	(void) event_data;
	(void) data;
	printf("In verify mpicoll list\n");
}
